// ControlApp2View.cpp : implementation of the CControlApp2View class
//

#include "stdafx.h"
#include "ControlApp2.h"

#include "ControlApp2Doc.h"
#include "ControlApp2View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CControlApp2View

IMPLEMENT_DYNCREATE(CControlApp2View, CView)

BEGIN_MESSAGE_MAP(CControlApp2View, CView)
	//{{AFX_MSG_MAP(CControlApp2View)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_EN_CHANGE(IDC_EDIT, OnEditChange)
	ON_BN_CLICKED(IDC_PUSHBUTTON, OnPushbuttonClicked)
	ON_BN_CLICKED(IDC_CHECKBUTTON, OnCheckboxClicked)
	ON_BN_CLICKED(IDC_RADIOBUTTON1, OnRadio1Clicked)
	ON_BN_CLICKED(IDC_RADIOBUTTON2, OnRadio2Clicked)
	ON_BN_CLICKED(IDC_RADIOBUTTON3, OnRadio3Clicked)
	ON_LBN_DBLCLK(IDC_LIST, OnListItemDblClk)
	ON_CBN_DBLCLK(IDC_COMBOBOX, OnComboItemDblClk)
	ON_CBN_SELENDOK(IDC_COMBOBOX2, OnComboSelEndOk)
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlApp2View construction/destruction

CControlApp2View::CControlApp2View()
{
	// TODO: add construction code here

}

CControlApp2View::~CControlApp2View()
{
}

BOOL CControlApp2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CControlApp2View drawing

void CControlApp2View::OnDraw(CDC* pDC)
{
	CControlApp2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

}

/////////////////////////////////////////////////////////////////////////////
// CControlApp2View diagnostics

#ifdef _DEBUG
void CControlApp2View::AssertValid() const
{
	CView::AssertValid();
}

void CControlApp2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CControlApp2Doc* CControlApp2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CControlApp2Doc)));
	return (CControlApp2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CControlApp2View message handlers

int CControlApp2View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	CreateStaticText();
	CreateEditBoxes();
	CreatePushbutton();
	CreateCheckbox();
	CreateRadioButtons();
	CreateListBox();
	CreateComboBoxes();

	m_whiteBrush.CreateSolidBrush(RGB(255,255,255));

	return 0;
}

void CControlApp2View::CreateStaticText()
{
	m_editStatic.Create("Edit Controls:",
		WS_CHILD | WS_VISIBLE,
		CRect(20, 20, 220, 40), this, 0);

	m_buttonStatic.Create("Pushbutton Control:",
		WS_CHILD | WS_VISIBLE,
		CRect(20, 120, 220, 140), this, 0);

	m_checkStatic.Create("Checkbox Control:",
		WS_CHILD | WS_VISIBLE,
		CRect(20, 200, 220, 220), this, 0);

	m_listStatic.Create("List Box Control:",
		WS_CHILD | WS_VISIBLE,
		CRect(200, 20, 320, 40), this, 0);

	m_comboStatic.Create("Simple Combo Box:",
		WS_CHILD | WS_VISIBLE,
		CRect(200, 125, 350, 145), this, 0);

	m_comboStatic2.Create("Drop Down Combo Box:",
		WS_CHILD | WS_VISIBLE,
		CRect(200, 275, 390, 295), this, 0);

}

void CControlApp2View::CreateEditBoxes()
{
	m_edit.Create(ES_AUTOHSCROLL | WS_CHILD | WS_VISIBLE
		| WS_BORDER, CRect(20, 40, 160, 60),
		this, IDC_EDIT);

	m_edit2.Create(ES_READONLY | WS_CHILD | WS_VISIBLE
		| WS_BORDER, CRect(20, 70, 160, 90), this, 0);
}

void CControlApp2View::CreatePushbutton()
{
	m_button.Create("Click Me", BS_PUSHBUTTON |
		WS_BORDER | WS_CHILD | WS_VISIBLE,
		CRect(20, 140, 160, 170), this, IDC_PUSHBUTTON);
}

void CControlApp2View::CreateCheckbox()
{
	m_checkButton.Create("Check Me",
		BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE, 
		CRect(20, 215, 140, 255), this, IDC_CHECKBUTTON);
}

void CControlApp2View::CreateRadioButtons()
{
	m_radioGroup.Create("Radio Buttons",
		BS_GROUPBOX | WS_CHILD | WS_VISIBLE,
		CRect(20, 270, 160, 370), this, 0);

	m_radioButton1.Create("Radio 1",
		BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE |
		WS_GROUP, CRect(40, 295, 110, 315),
		this, IDC_RADIOBUTTON1);

	m_radioButton1.SetCheck(BST_CHECKED);

	m_radioButton2.Create("Radio 2",
		BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
		CRect(40, 315, 110, 335), this,
		IDC_RADIOBUTTON2);

	m_radioButton3.Create("Radio 3",
		BS_AUTORADIOBUTTON | WS_CHILD | WS_VISIBLE,
		CRect(40, 335, 110, 355), this,
		IDC_RADIOBUTTON3);
}

void CControlApp2View::CreateListBox()
{
	m_listBox.Create(LBS_STANDARD | WS_CHILD |
		WS_VISIBLE | WS_GROUP,
		CRect(200, 40, 340, 120), this, IDC_LIST);

	m_listBox.AddString("List Box Item 1");
	m_listBox.AddString("List Box Item 2");
	m_listBox.AddString("List Box Item 3");
	m_listBox.AddString("List Box Item 4");
	m_listBox.AddString("List Box Item 5");
	m_listBox.AddString("List Box Item 6");
	m_listBox.AddString("List Box Item 7");
}

void CControlApp2View::CreateComboBoxes()
{
	m_comboBox.Create(CBS_SIMPLE | CBS_SORT |
		WS_CHILD | WS_VISIBLE | WS_GROUP,
		CRect(200, 145, 340, 255), this, IDC_COMBOBOX);

	m_comboBox.AddString("Combo Box Item 1");
	m_comboBox.AddString("Combo Box Item 2");
	m_comboBox.AddString("Combo Box Item 3");
	m_comboBox.AddString("Combo Box Item 4");
	m_comboBox.AddString("Combo Box Item 5");
	m_comboBox.AddString("Combo Box Item 6");
	m_comboBox.AddString("Combo Box Item 7");

	m_comboBox2.Create(CBS_DROPDOWN | CBS_SORT |
		WS_CHILD | WS_VISIBLE | WS_VSCROLL, 
		CRect(200, 295, 360, 375), this, IDC_COMBOBOX2);

	m_comboBox2.AddString("Combo Box Item 1");
	m_comboBox2.AddString("Combo Box Item 2");
	m_comboBox2.AddString("Combo Box Item 3");
	m_comboBox2.AddString("Combo Box Item 4");
	m_comboBox2.AddString("Combo Box Item 5");
	m_comboBox2.AddString("Combo Box Item 6");
	m_comboBox2.AddString("Combo Box Item 7");
}

void CControlApp2View::OnPushbuttonClicked()
{
	MessageBox("Pushbutton clicked!");
}

void CControlApp2View::OnRadio1Clicked()
{
	MessageBox("Radio Button 1");
}

void CControlApp2View::OnRadio2Clicked()
{
	MessageBox("Radio Button 2");
}

void CControlApp2View::OnRadio3Clicked()
{
	MessageBox("Radio Button 3");
}

HBRUSH CControlApp2View::OnCtlColor
    (CDC* pDC, CWnd* pWnd, UINT nCtrlColor)
{
	if ((nCtrlColor == CTLCOLOR_STATIC) &&
		  (pWnd->m_hWnd != m_edit2.m_hWnd))
        return (HBRUSH)m_whiteBrush;

	return CView::OnCtlColor(pDC, pWnd, nCtrlColor);
}

void CControlApp2View::OnCheckboxClicked()
{
	int checked = m_checkButton.GetCheck();

	if (checked == BST_CHECKED)
	    MessageBox("Checkbutton checked!");
	else if (checked == BST_UNCHECKED)
	    MessageBox("Checkbutton unchecked!");
}

void CControlApp2View::OnListItemDblClk()
{
	int selection = m_listBox.GetCurSel();
	char str[81];
	m_listBox.GetText(selection, str);
	MessageBox(str);
}

void CControlApp2View::OnEditChange()
{
	char str[81];
    m_edit.GetWindowText(str, 80);
	m_edit2.SetWindowText(str);
}

void CControlApp2View::OnComboItemDblClk()
{
	int selection = m_comboBox.GetCurSel();
	char str[81];
	m_comboBox.GetLBText(selection, str);
	MessageBox(str);
}

void CControlApp2View::OnComboSelEndOk()
{
	int selection = m_comboBox2.GetCurSel();
	char str[81];
	m_comboBox2.GetLBText(selection, str);
	MessageBox(str);
}

